angular.module('ngApp')
// RSS Feeds Controller
.controller('RssCtrl', function($scope, $http, localStorage) {
  $scope.feeds = []
  $scope.storage = '';
  var data;

  $scope.$watch('sl', function () {
    $scope.showFeed(false);
  });
  
  $scope.showFeed = function(refresh){
    data = localStorage.all($scope.hash);
    if(data){
      $scope.feeds = data.entries;
    }
    if(isOnline()){
      if(!refresh){
        $scope.loading = true;
      }
      
      $http({method: 'GET', noLoading : true, url: url + '/api/v1/widget/get/rss/getFeed?sl=' + $scope.sl})
      .success(function(data) {
        $scope.$broadcast('scroll.refreshComplete');
        $scope.storage = 'خطا در اتصال به سرور';
        if(data){
          data.entries = $scope.getFirstImage(data.entries);      
          $scope.storage = data.error;
          localStorage.save(data,$scope.hash);     
          $scope.feeds = data.entries;
        }
        $scope.loading = false;
      })
      .error(function() {
          $scope.$broadcast('scroll.refreshComplete');
          data = localStorage.all($scope.hash);
          $scope.storage = 'خطا در اتصال به سرور';
          $scope.feeds = data.entries;
          $scope.loading = false;
      });
    }else{
      $scope.loading = false;
      window.plugins.toast.showWithOptions({ message: "اتصال اینترنت خود را بررسی کنید", duration: "short", position: "bottom", addPixelsY: -50 });
    }
  }

  $scope.doRefresh = function() {
      $scope.showFeed(true);
  };

  $scope.getFirstImage = function(entries) {
    for (i = 0; i < entries.length; i++) {
      if(entries[i].image == ''){
        var tagIndex = entries[i].content.indexOf('<img');
        if(tagIndex >= 0){
          var srcIndex = entries[i].content.substring(tagIndex).indexOf('src=') + tagIndex; // Find where the src attribute starts
          var srcStart = srcIndex + 5; // Find where the actual image URL starts; 5 for the length of 'src="'
          var srcEnd = entries[i].content.substring(srcStart).indexOf('"') + srcStart; // Find where the URL ends
          var src = entries[i].content.substring(srcStart, srcEnd);
          entries[i].image = src;
        }
      }
    }
    return entries;
  };

})

// RSS Feed Controller
.controller('FeedCtrl', function($scope, $stateParams, localStorage) {
    var data = localStorage.all($stateParams.hashCode);
    $scope.entry = data.entries[$stateParams.entryId];
    
    $scope.loadURL = function () {
        window.open($scope.entry.link,'_system');
    }
    
    $scope.shareEntry = function () {
        var message = $scope.entry.title;
        message = message.replace(/(<([^>]+)>)/ig,"");
        message = message.substring(0,100);
        message = message + ' ...';

        var link = $scope.entry.link;
        window.plugins.socialsharing.share(null, message, null, link);
    }
})
;